## ros-rolling-serial-driver 1.0.1

=== CMakeLists.txt ===
# Copyright 2018 Apex.AI, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# Co-developed by Tier IV, Inc. and Apex.AI, Inc.
cmake_minimum_required(VERSION 3.5)
project(serial_driver)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

## dependencies
find_package(ament_cmake_auto REQUIRED)
ament_auto_find_build_dependencies()

find_package(asio_cmake_module REQUIRED)
find_package(ASIO REQUIRED)

ament_auto_add_library(${PROJECT_NAME} SHARED
  src/serial_port.cpp
  src/serial_driver.cpp
)

ament_target_dependencies(${PROJECT_NAME} "ASIO")

ament_auto_add_library(${PROJECT_NAME}_nodes SHARED
  src/serial_bridge_node.cpp
)

rclcpp_components_register_node(${PROJECT_NAME}_nodes
  PLUGIN "drivers::serial_driver::SerialBridgeNode"
  EXECUTABLE "serial_bridge"
)

target_link_libraries(${PROJECT_NAME}_nodes ${PROJECT_NAME})
ament_target_dependencies(${PROJECT_NAME}_nodes "ASIO")

if(BUILD_TESTING)
  find_package(ament_lint_auto)
  ament_lint_auto_find_test_dependencies()

  set(TEST_FILES
    test/test_serial_driver.cpp
    test/test_serial_port.cpp
  )

  foreach(file ${TEST_FILES})
    get_filename_component(name "${file}" NAME_WE)
    set(TEST_SERIAL_DRIVER_EXE ${name})

    ament_add_gtest(${TEST_SERIAL_DRIVER_EXE}
      test/${name}.cpp
    )
    ament_target_dependencies(${TEST_SERIAL_DRIVER_EXE}
      rclcpp
      example_interfaces
      lifecycle_msgs
      ASIO
    )
    target_include_directories(${TEST_SERIAL_DRIVER_EXE} PRIVATE include)
    target_link_libraries(${TEST_SERIAL_DRIVER_EXE} ${PROJECT_NAME} ${PROJECT_NAME_NODES})
  endforeach()
endif()

ament_auto_package(
  CONFIG_EXTRAS_POST "serial_driver-extras.cmake"
  INSTALL_TO_SHARE
    launch
    params
)

=== debian/changelog ===
ros-rolling-serial-driver (1.0.1-1focal) focal; urgency=high

  * Remove deprecated api from galactic (#57 <https://github.com/ros-drivers/transport_drivers/issues/57>)
  * Serial driver debugs (#56 <https://github.com/ros-drivers/transport_drivers/issues/56>)
    * debugged message conversion
    debugged serial bridge segfault (publisher accessed before initialized)
    * refactored message conversion
  * update READMEs for each package (#54 <https://github.com/ros-drivers/transport_drivers/issues/54>)
    * update READMEs for each package
    * add more to readme, renamed config to params
  * Port udp_driver Changes to serial_driver (#47 <https://github.com/ros-drivers/transport_drivers/issues/47>)
    * Adding SerialPort and framework for SerialDriver.
    * Adding SerialDriver
    * Adding SerialBridgeNode
    * Remove serial_driver_node and tests
    * Create new tests for serial_port and serial_driver
    * Changing signature of from_msg for example_interfaces
    * [serial_driver] Adding missing function definition
    * [serial_driver] Adding example params and launch files
    * Trying to apease flake8
    * Fixing allocation snafu
    * [serial_driver] Replacing MutBuffer with std::vector<uint8_t>
    * [serial_driver] Fix typo
    * [serial_driver] Make launch file more reliable
    * [serial_driver] Fix error message
    * [serial_driver] Fix typo
    * [serial_driver] Shorten node name
  * Export ASIO definitions (#44 <https://github.com/ros-drivers/transport_drivers/issues/44>)
  * Enforce C++14. Do not duplicate compiler flags (#45 <https://github.com/ros-drivers/transport_drivers/issues/45>)
  * Deduplicate ASIO CMake module (#43 <https://github.com/ros-drivers/transport_drivers/issues/43>)
    * Added ASIO CMake module
    * Use asio_cmake_module
  * Fix copyright years (#41 <https://github.com/ros-drivers/transport_drivers/issues/41>)
  * Removed Boost (#39 <https://github.com/ros-drivers/transport_drivers/issues/39>)
    * Removed Boost
    * Do not depend on Boost at all
    * Added cmath header
    * Fix linting warning
    * Added ASIO_STANDALONE to more units
    * Call stop on io_service
    * Fix dependency
    * Export asio as a downstream dependency
    * Remove more boost references
    * Force non-Boost version of ASIO
    * Force non-Boost version of ASIO
    * Ignore result to avoid compiler warning
  * remove autoware namespace (#35 <https://github.com/ros-drivers/transport_drivers/issues/35>)
    * remove autoware namespace
    * move msgs namespace to utils
  * Make Nodes Component-Compatible (#22 <https://github.com/ros-drivers/transport_drivers/issues/22>)
    * Making constructors for SerialDriverNode component-compatible.
    * Making constructors for UdpDriverNode component-compatible.
  * Contributors: Daisuke Nishimatsu, Esteve Fernandez, Evan Flynn, Haoru Xue, Joshua Whitley

 -- Joshua Whitley <whitleysoftwareservices@gmail.com>  Mon, 30 Aug 2021 05:00:00 -0000

ros-rolling-serial-driver (0.0.6-1focal) focal; urgency=high

  * Uncrustify fixes.
  * Remove lifecycle references (#19 <https://github.com/ros-drivers/transport_drivers/issues/19>)
  * Fixing boost dependency. (#18 <https://github.com/ros-drivers/transport_drivers/issues/18>)
  * Contributors: Esteve Fernandez, Joshua Whitley

 -- Joshua Whitley <whitleysoftwareservices@gmail.com>  Thu, 27 Aug 2020 05:00:00 -0000

ros-rolling-serial-driver (0.0.5-1focal) focal; urgency=high

  * Remove Autoware.AUTO Dependencies (#15 <https://github.com/ros-drivers/transport_drivers/issues/15>)
    * Removing autoware dependencies.
    * Fixing linting errors.
    * Addressing review feedback.
  * Be specific about which parts of Boost are necessary (#10 <https://github.com/ros-drivers/transport_drivers/issues/10>)
    * serial: be specific about Boost dependency.
    * udp: be specific about Boost dependency.
  * Contributors: G.A. vd. Hoorn, Joshua Whitley

 -- Joshua Whitley <whitleysoftwareservices@gmail.com>  Thu, 16 Jul 2020 05:00:00 -0000

ros-rolling-serial-driver (0.0.4-1focal) focal; urgency=high

  * Making serial_driver version number consistent with repo.
  * Initial commit of serial_driver.
  * Contributors: Joshua Whitley

 -- Joshua Whitley <whitleysoftwareservices@gmail.com>  Thu, 12 Dec 2019 06:00:00 -0000

ros-rolling-serial-driver (0.0.3-1focal) focal; urgency=high



 -- Joshua Whitley <whitleysoftwareservices@gmail.com>  Wed, 21 Aug 2019 05:00:00 -0000

ros-rolling-serial-driver (0.0.2-1focal) focal; urgency=high



 -- Joshua Whitley <whitleysoftwareservices@gmail.com>  Mon, 19 Aug 2019 05:00:00 -0000

=== debian/control ===
Source: ros-rolling-serial-driver
Section: misc
Priority: optional
Maintainer: Joshua Whitley <whitleysoftwareservices@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libasio-dev, ros-rolling-ament-cmake-auto, ros-rolling-ament-cmake-gtest, ros-rolling-ament-lint-auto, ros-rolling-ament-lint-common, ros-rolling-asio-cmake-module, ros-rolling-io-context, ros-rolling-rclcpp, ros-rolling-rclcpp-components, ros-rolling-rclcpp-lifecycle, ros-rolling-std-msgs, ros-rolling-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-rolling-serial-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libasio-dev, ros-rolling-io-context, ros-rolling-rclcpp, ros-rolling-rclcpp-components, ros-rolling-rclcpp-lifecycle, ros-rolling-std-msgs, ros-rolling-ros-workspace
Description: A template class and associated utilities which encapsulate basic reading from serial ports

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/rolling/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-rolling-serial-driver//opt/ros/rolling/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_install

## ros-rolling-serial-driver 1.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -69,7 +69,6 @@
     )
     ament_target_dependencies(${TEST_SERIAL_DRIVER_EXE}
       rclcpp
-      example_interfaces
       lifecycle_msgs
       ASIO
     )

=== debian/changelog ===
ros-rolling-serial-driver (1.2.0-2jammy) jammy; urgency=high

  * Disable broken test.
  * Fix linter errors.
  * Contributors: WhitleySoftwareServices

 -- Joshua Whitley <whitleysoftwareservices@gmail.com>  Sun, 20 Mar 2022 07:00:00 -0000

ros-rolling-serial-driver (1.1.0-2jammy) jammy; urgency=high

  * Support serial_break (#76 <https://github.com/ros-drivers/transport_drivers/issues/76>)
    * Support serial_break
    * Add protection to serial break and unit tests
  * Fix the converter Converter between std_msgs::msg::UInt8MultiArray and std::vector<uint8_t> (#73 <https://github.com/ros-drivers/transport_drivers/issues/73>)
    * example_interfaces is redundant as std_msgs includes UInt8MultiArray
    * udp_msgs.hpp should not include "converters.hpp"
    * Fix the converter std_msgs::msg::UInt8MultiArray <-> std::vector<uint8_t>
  * Add support for Foxy (#68 <https://github.com/ros-drivers/transport_drivers/issues/68>)
    * Add support for Foxy
    * Use same API signature for all ROS distros
  * Contributors: ChenJun, Esteve Fernandez, RFRIEDM-Trimble

 -- Joshua Whitley <whitleysoftwareservices@gmail.com>  Sun, 20 Mar 2022 07:00:00 -0000

ros-rolling-serial-driver (1.0.1-2jammy) jammy; urgency=high

  * Remove deprecated api from galactic (#57 <https://github.com/ros-drivers/transport_drivers/issues/57>)
  * Serial driver debugs (#56 <https://github.com/ros-drivers/transport_drivers/issues/56>)
    * debugged message conversion
    debugged serial bridge segfault (publisher accessed before initialized)
    * refactored message conversion
  * update READMEs for each package (#54 <https://github.com/ros-drivers/transport_drivers/issues/54>)
    * update READMEs for each package
    * add more to readme, renamed config to params
  * Port udp_driver Changes to serial_driver (#47 <https://github.com/ros-drivers/transport_drivers/issues/47>)
    * Adding SerialPort and framework for SerialDriver.
    * Adding SerialDriver
    * Adding SerialBridgeNode
    * Remove serial_driver_node and tests
    * Create new tests for serial_port and serial_driver
    * Changing signature of from_msg for example_interfaces
    * [serial_driver] Adding missing function definition
    * [serial_driver] Adding example params and launch files
    * Trying to apease flake8
    * Fixing allocation snafu
    * [serial_driver] Replacing MutBuffer with std::vector<uint8_t>
    * [serial_driver] Fix typo
    * [serial_driver] Make launch file more reliable
    * [serial_driver] Fix error message
    * [serial_driver] Fix typo
    * [serial_driver] Shorten node name
  * Export ASIO definitions (#44 <https://github.com/ros-drivers/transport_drivers/issues/44>)
  * Enforce C++14. Do not duplicate compiler flags (#45 <https://github.com/ros-drivers/transport_drivers/issues/45>)
  * Deduplicate ASIO CMake module (#43 <https://github.com/ros-drivers/transport_drivers/issues/43>)
    * Added ASIO CMake module
    * Use asio_cmake_module
  * Fix copyright years (#41 <https://github.com/ros-drivers/transport_drivers/issues/41>)
  * Removed Boost (#39 <https://github.com/ros-drivers/transport_drivers/issues/39>)
    * Removed Boost
    * Do not depend on Boost at all
    * Added cmath header
    * Fix linting warning
    * Added ASIO_STANDALONE to more units
    * Call stop on io_service
    * Fix dependency
    * Export asio as a downstream dependency
    * Remove more boost references
    * Force non-Boost version of ASIO
    * Force non-Boost version of ASIO
    * Ignore result to avoid compiler warning
  * remove autoware namespace (#35 <https://github.com/ros-drivers/transport_drivers/issues/35>)
    * remove autoware namespace
    * move msgs namespace to utils
  * Make Nodes Component-Compatible (#22 <https://github.com/ros-drivers/transport_drivers/issues/22>)
    * Making constructors for SerialDriverNode component-compatible.
    * Making constructors for UdpDriverNode component-compatible.
  * Contributors: Daisuke Nishimatsu, Esteve Fernandez, Evan Flynn, Haoru Xue, Joshua Whitley

 -- Joshua Whitley <whitleysoftwareservices@gmail.com>  Mon, 30 Aug 2021 07:00:00 -0000

ros-rolling-serial-driver (0.0.6-2jammy) jammy; urgency=high

  * Uncrustify fixes.
  * Remove lifecycle references (#19 <https://github.com/ros-drivers/transport_drivers/issues/19>)
  * Fixing boost dependency. (#18 <https://github.com/ros-drivers/transport_drivers/issues/18>)
  * Contributors: Esteve Fernandez, Joshua Whitley

 -- Joshua Whitley <whitleysoftwareservices@gmail.com>  Thu, 27 Aug 2020 07:00:00 -0000

ros-rolling-serial-driver (0.0.5-2jammy) jammy; urgency=high

  * Remove Autoware.AUTO Dependencies (#15 <https://github.com/ros-drivers/transport_drivers/issues/15>)
    * Removing autoware dependencies.
    * Fixing linting errors.
    * Addressing review feedback.
  * Be specific about which parts of Boost are necessary (#10 <https://github.com/ros-drivers/transport_drivers/issues/10>)
    * serial: be specific about Boost dependency.
    * udp: be specific about Boost dependency.
  * Contributors: G.A. vd. Hoorn, Joshua Whitley

 -- Joshua Whitley <whitleysoftwareservices@gmail.com>  Thu, 16 Jul 2020 07:00:00 -0000

ros-rolling-serial-driver (0.0.4-2jammy) jammy; urgency=high

  * Making serial_driver version number consistent with repo.
  * Initial commit of serial_driver.
  * Contributors: Joshua Whitley

 -- Joshua Whitley <whitleysoftwareservices@gmail.com>  Thu, 12 Dec 2019 08:00:00 -0000

ros-rolling-serial-driver (0.0.3-2jammy) jammy; urgency=high



 -- Joshua Whitley <whitleysoftwareservices@gmail.com>  Wed, 21 Aug 2019 07:00:00 -0000

ros-rolling-serial-driver (0.0.2-2jammy) jammy; urgency=high



 -- Joshua Whitley <whitleysoftwareservices@gmail.com>  Mon, 19 Aug 2019 07:00:00 -0000

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: misc
 Priority: optional
 Maintainer: Joshua Whitley <whitleysoftwareservices@gmail.com>
-Build-Depends: debhelper (>= 9.0.0), libasio-dev, ros-rolling-ament-cmake-auto, ros-rolling-ament-cmake-gtest, ros-rolling-ament-lint-auto, ros-rolling-ament-lint-common, ros-rolling-asio-cmake-module, ros-rolling-io-context, ros-rolling-rclcpp, ros-rolling-rclcpp-components, ros-rolling-rclcpp-lifecycle, ros-rolling-std-msgs, ros-rolling-ros-workspace
+Build-Depends: debhelper (>= 9.0.0), libasio-dev, ros-rolling-ament-cmake-auto, ros-rolling-ament-cmake-gtest <!nocheck>, ros-rolling-ament-lint-auto <!nocheck>, ros-rolling-ament-lint-common <!nocheck>, ros-rolling-asio-cmake-module, ros-rolling-io-context, ros-rolling-rclcpp, ros-rolling-rclcpp-components, ros-rolling-rclcpp-lifecycle, ros-rolling-std-msgs, ros-rolling-ros-workspace
 Homepage: 
 Standards-Version: 3.9.2

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
 		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"
+		-DCMAKE_PREFIX_PATH="/opt/ros/rolling" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
